%bcond_without check

%global bundled_rust_deps 0

%define url_ver %{lua: ver = rpm.expand("%{version}"); majmin, count1 = string.gsub(ver, "^(%d+%.%d+).*", "%1", 1); if count1 == 0 then print(ver); return; end; maj, count2 = string.gsub(majmin, "^(%d+).*", "%1", 1); if count2 == 0 then print(majmin) elseif tonumber(majmin) < 40 then print(majmin) else print(maj) end}

%global tarball_version %%(echo %{version} | tr '~' '.')

Name:           loupe
Version:        47.2
Release:        %mkrel 3
Summary:        Image viewer
Group:          Graphical desktop/GNOME

# (MIT OR Apache-2.0) AND Unicode-DFS-2016
# 0BSD OR MIT OR Apache-2.0
# Apache-2.0 OR MIT
# Apache-2.0 WITH LLVM-exception OR Apache-2.0 OR MIT
# BSD-2-Clause
# GPL-3.0-or-later
# LGPL-2.1-only
# MIT
# MIT OR Apache-2.0
# MIT OR Apache-2.0 OR Zlib
# MIT OR Zlib OR Apache-2.0
# Unlicense OR MIT
# Zlib OR Apache-2.0 OR MIT
License:        (MIT OR Apache-2.0) AND Unicode-DFS-2016 AND (0BSD OR MIT OR Apache-2.0) AND (Apache-2.0 OR MIT) AND (Apache-2.0 WITH LLVM-exception OR Apache-2.0 OR MIT) AND BSD-2-Clause AND GPL-3.0-or-later AND LGPL-2.1-only AND MIT AND (MIT OR Apache-2.0) AND (MIT OR Apache-2.0 OR Zlib) AND (MIT OR Zlib OR Apache-2.0) AND (Unlicense OR MIT) AND (Zlib OR Apache-2.0 OR MIT)
# LICENSE.dependencies contains a full license breakdown
URL:            https://gitlab.gnome.org/GNOME/loupe
Source0:        https://download.gnome.org/sources/loupe/%{url_ver}/loupe-%{tarball_version}.tar.xz

BuildRequires:  cargo-rpm-macros
BuildRequires:  itstool
BuildRequires:  meson
%if 0%{?bundled_rust_deps}
BuildRequires:  pkgconfig(gtk4)
BuildRequires:  pkgconfig(gweather4)
BuildRequires:  pkgconfig(lcms2)
BuildRequires:  pkgconfig(libadwaita-1)
BuildRequires:  pkgconfig(libheif) >= 1.14.2
BuildRequires:  pkgconfig(libseccomp) >= 2.5.0
%else
BuildRequires:  rust-ashpd+gtk4_x11-devel
%endif
BuildRequires:  appstream-util
BuildRequires:  desktop-file-utils

# For /usr/share/dbus-1/services directory
Requires:       dbus
# Image loaders used by loupe
Requires:       glycin-loaders

%description
An image viewer application written with GTK 4, Libadwaita and Rust.

Features:

- Fast GPU accelerated image rendering with tiled rendering for SVGs
- Extendable and sandboxed (expect SVG) image decoding
- Support for more than 15 image formats by default
- Extensive support for touchpad and touchscreen gestures
- Accessible presentation of the most important metadata
- Sleek but powerful interface developed in conjunction with GNOME Human
  Interface Guidelines


%prep
%autosetup -p1 -n loupe-%{tarball_version}

%if ! 0%{?bundled_rust_deps}
rm -rf vendor
sed -i -e '/Cargo.lock/d' meson.build
%cargo_prep
%endif

%ifarch %{arm32} %{ix86}
# Disable LTO on 32 bit arches
# https://gitlab.gnome.org/GNOME/loupe/-/issues/445
sed -i -e 's/\(^lto\s\+=\s\+\).*/\1false/' Cargo.toml
%endif

%if ! 0%{?bundled_rust_deps}
%generate_buildrequires
%cargo_generate_buildrequires
%endif


%build
%meson
%meson_build


%install
%meson_install

%find_lang loupe --with-gnome

%if %{with check}
%check
%meson_test
%endif


%files -f loupe.lang
%license COPYING.md
%doc NEWS README.md
%{_bindir}/loupe
%{_datadir}/applications/org.gnome.Loupe.desktop
%{_datadir}/dbus-1/services/org.gnome.Loupe.service
%{_datadir}/icons/hicolor/scalable/apps/org.gnome.Loupe*.svg
%{_datadir}/icons/hicolor/symbolic/apps/org.gnome.Loupe-symbolic.svg
%{_metainfodir}/org.gnome.Loupe.metainfo.xml
%{_datadir}/glib-2.0/schemas/org.gnome.Loupe.gschema.xml


%changelog
* Tue Dec 31 2024 wally <wally> 47.2-3.mga10
+ Revision: 2134136
- enable 32 bit builds again (without LTO)

* Tue Dec 31 2024 wally <wally> 47.2-2.mga10
+ Revision: 2133437
- disable 32 bit builds
- enable i686 build (SILNET)
- build using system rust pkgs

* Sun Dec 29 2024 daviddavid <daviddavid> 47.2-1.mga10
+ Revision: 2131001
- new version 47.2

* Thu Nov 07 2024 daviddavid <daviddavid> 47.1-1.mga10
+ Revision: 2112824
- new version 47.1

* Thu Sep 19 2024 daviddavid <daviddavid> 47.0-1.mga10
+ Revision: 2098994
- new version 47.0
- new version 46.0
- new version 45.2

* Tue Oct 17 2023 tv <tv> 45.0-2.mga10
+ Revision: 1997881
- imported package loupe


* Thu Sep 28 2023 Thierry Vignaud <tv@mageia.org> 45.0-1.mga10
- Import from FC

* Tue Sep 19 2023 Kalev Lember <klember@redhat.com> - 45.0-1
- Update to 45.0

* Thu Sep 07 2023 Kalev Lember <klember@redhat.com> - 45~beta.1-6
- ExcludeArch i686 for
  https://fedoraproject.org/wiki/Changes/EncourageI686LeafRemoval

* Thu Sep 07 2023 Kalev Lember <klember@redhat.com> - 45~beta.1-5
- Use bundled rust deps on RHEL

* Mon Aug 21 2023 Kalev Lember <klember@redhat.com> - 45~beta.1-4
- Buildrequire cargo-rpm-macros instead of rust-packaging

* Mon Aug 21 2023 Kalev Lember <klember@redhat.com> - 45~beta.1-3
- Add check bcond to ensure cargo_buildrequires does the right thing

* Mon Aug 21 2023 Kalev Lember <klember@redhat.com> - 45~beta.1-2
- Require dbus and hicolor-icon-theme for directory ownership

* Mon Aug 21 2023 Kalev Lember <klember@redhat.com> - 45~beta.1-1
- Initial Fedora packaging (rhbz#2233324)
